OSDN Git Service

df6ad80ae2f2655c386384b4272dd84ca4005123
[pf3gnuchains/gcc-fork.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File:   gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date:   2001-05-25
8 #
9 # Contents:
10 #   Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GCC.
15 #
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING.  If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 #   gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53     echo "gcc_release: error: $1"
54     exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60     echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release -r release [further options]
68 gcc_release -s [further options]
69
70 Options:
71
72   -r release           Version of the form X.Y or X.Y.Z.
73   -s                   Create a snapshot, not a real release.
74
75   -d destination       Local working directory where we will build the release
76                        (default=${HOME}).
77   -f                   Create a final release (and update ChangeLogs,...).
78   -l                   Indicate that we are running on gcc.gnu.org.
79   -p previous-tarball  Location of a previous tarball (to generate diff files).
80   -t tag               Tag to mark the release in CVS.
81   -u username          Username for upload operations.
82 EOF
83     exit 1
84 }
85
86 # Change to the directory given by $1.
87
88 changedir() {
89   cd $1 || \
90     error "Could not change directory to $1"
91 }
92
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree.  Return another name for that directory, relative
95 # to the working directory.
96
97 adjust_dirs() {
98   for x in $@; do
99     echo `basename ${SOURCE_DIRECTORY}`/$x
100   done
101 }
102
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106 build_sources() {
107   # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108   if [ -r ${WORKING_DIRECTORY} ]; then
109     error "\`${WORKING_DIRECTORY}' already exists"
110   fi
111   # Create the WORKING_DIRECTORY.
112   mkdir "${WORKING_DIRECTORY}" \
113     || error "Could not create \`${WORKING_DIRECTORY}'"
114   changedir "${WORKING_DIRECTORY}"
115
116   # If this is a final release, make sure that the ChangeLogs
117   # and version strings are updated.
118   if [ ${FINAL} -ne 0 ]; then
119     inform "Updating ChangeLogs and version files"
120
121     ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122            -r ${BRANCH} gcc || \
123            error "Could not check out release sources"
124     for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125       # Update this ChangeLog file only if it does not yet contain the
126       # entry we are going to add.  (This is a safety net for repeated
127       # runs of this script for the same release.)
128       if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then       
129         cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE}  Release Manager
131
132         * GCC ${RELEASE} released.
133
134 EOF
135         mv ${x}.new ${x} || \
136             error "Could not update ${x}"
137         (changedir `dirname ${x}` && \
138             ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139             error "Could not commit ${x}"
140       fi
141     done
142
143     # Update `gcc/version.c'.
144     for x in gcc/version.c; do 
145       y=`basename ${x}`
146       (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147           sed -e 's|= \".*\"|= \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148           mv ${y}.new ${y} && \
149           ${CVS} ci -m 'Update version' ${y}) || \
150           error "Could not update ${x}"
151     done
152
153     # Make sure we tag the sources for a final release.
154     TAG="gcc_`echo ${RELEASE} | tr . _`_release"
155
156     rm -rf ${SOURCE_DIRECTORY}
157   fi
158
159   # Tag the sources.
160   if [ -n "${TAG}" ]; then
161     inform "Tagging release sources"
162     ${CVS} rtag -r ${BRANCH} -F ${TAG} gcc || \
163       error "Could not tag release sources"
164     BRANCH=$TAG
165   fi
166
167   # Export the current sources.
168   inform "Retrieving release sources"
169   ${CVS} \
170        export -d "`basename ${SOURCE_DIRECTORY}`" \
171        -r ${BRANCH} gcc || \
172     error "Could not retrieve release sources"
173
174   # Run gcc_update on them to set up the timestamps nicely.
175   changedir "gcc-${RELEASE}"
176   contrib/gcc_update --touch
177
178   # Obtain some documentation files from the wwwdocs module.
179   inform "Retrieving HTML documentation"
180   changedir "${WORKING_DIRECTORY}"
181   for x in bugs gnats faq; do
182     (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
183      cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
184         ${SOURCE_DIRECTORY}) || \
185       error "Could not retrieve ${x}.html"
186   done
187
188   inform "Generating plain-text documentation from HTML"
189   changedir "${SOURCE_DIRECTORY}"
190   for file in *.html; do
191     newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
192     (${ENV} TERM=vt100 lynx -dump $file \
193        | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
194        > $newfile) || \
195      error "Could not regenerate documentation"
196   done
197
198   # For a prerelease or real release, we need to generate additional
199   # files not present in CVS.
200   changedir "${SOURCE_DIRECTORY}"
201   if [ $SNAPSHOT -ne 1 ]; then
202     # Generate the documentation.
203     inform "Building install docs"
204     SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
205     DESTDIR=${SOURCE_DIRECTORY}/INSTALL
206     export SOURCEDIR
207     export DESTDIR
208     ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
209
210     # Regenerate the NEWS file.
211     contrib/gennews > gcc/NEWS || \
212       error "Could not regenerate NEWS files"
213
214     # Now, we must build the compiler in order to create any generated
215     # files that are supposed to go in the source directory.  This is
216     # also a good sanity check to make sure that the release builds
217     # on at least one platform.
218     inform "Building compiler"
219     OBJECT_DIRECTORY=../objdir
220     contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
221       error "Could not rebuild GCC"
222
223     # Regenerate the Fotran NEWS and BUGS files.
224     (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
225       error "Could not regenerate Fortran NEWS and BUGS files"
226   fi
227
228   # Move message catalogs to source directory.
229   mv ../objdir/gcc/po/*.gmo gcc/po/
230
231   # Create a `.brik' file to use for checking the validity of the
232   # release.
233   changedir "${SOURCE_DIRECTORY}"
234   BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
235   ((find . -type f | sort > $BRIK_FILE) && \
236        brik -Gb -f ${BRIK_FILE} > .brik && \
237        rm ${BRIK_FILE}) || \
238      error "Could not compute brik checksum"
239 }
240
241 # Buid a single tarfile.  The first argument is the name of the name
242 # of the tarfile to build, without any suffixes.  They will be added
243 # automatically.  The rest of the arguments are the files or
244 # directories to include.
245
246 build_tarfile() {
247   # Get the name of the destination tar file.
248   TARFILE="$1.tar.gz"
249   shift
250
251   # Build the tar file itself.
252   (${TAR} cf - "$@" | ${GZIP} > ${TARFILE}) || \
253     error "Could not build tarfile"
254   FILE_LIST="${FILE_LIST} ${TARFILE}"
255 }
256
257 # Build the various tar files for the release.
258
259 build_tarfiles() {
260   inform "Building tarfiles"
261
262   changedir "${WORKING_DIRECTORY}"
263
264   # The GNU Coding Standards specify that all files should
265   # world readable.
266   chmod -R a+r ${SOURCE_DIRECTORY}
267   # And that all directories have mode 777.
268   find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
269  
270   # Build one huge tarfile for the entire distribution.
271   build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
272
273   # Now, build one for each of the languages.
274   build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
275   build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
276   build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
277   build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
278   build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
279   build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
280    
281   # The core is everything else.
282   EXCLUDES=""
283   for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
284            ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
285     EXCLUDES="${EXCLUDES} --exclude $x"
286   done
287   build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
288     `basename ${SOURCE_DIRECTORY}`
289 }
290
291 # Build .bz2 files.
292 build_bzip2() {
293   for f in ${FILE_LIST}; do
294     bzfile=${f%.gz}.bz2
295     (zcat $f | ${BZIP2} > ${bzfile}) || error "Could not create ${bzfile}"
296   done
297 }
298
299 # Build diffs against an old release.
300 build_diffs() {
301   old_dir=${1%/*}
302   old_file=${1##*/}
303   old_vers=${old_file%.tar.gz}
304   old_vers=${old_vers#gcc-}
305   inform "Building diffs against version $old_vers"
306   for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
307     old_tar=${old_dir}/${f}-${old_vers}.tar.gz
308     new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.gz
309     if [ ! -e $old_tar ]; then
310       inform "$old_tar not found; not generating diff file"
311     elif [ ! -e $new_tar ]; then
312       inform "$new_tar not found; not generating diff file"
313     else
314       build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
315         ${f}-${old_vers}-${RELEASE}.diff.gz
316     fi
317   done
318 }
319
320 # Build an individual diff.
321 build_diff() {
322   changedir "${WORKING_DIRECTORY}"
323   tmpdir=gccdiff.$$
324   mkdir $tmpdir || error "Could not create directory $tmpdir"
325   changedir $tmpdir
326   tar xfz $1 || error "Could not unpack $1 for diffs"
327   tar xfz $3 || error "Could not unpack $3 for diffs"
328   ${DIFF} $2 $4 > ../${5%.gz}
329   if [ $? -eq 2 ]; then
330     error "Trouble making diffs from $1 to $3"
331   fi
332   ${GZIP} ../${5%.gz} || error "Could not gzip ../${5%.gz}"
333   changedir ..
334   rm -rf $tmpdir
335   FILE_LIST="${FILE_LIST} $5"
336 }
337
338 # Upload the files to the FTP server.
339
340 upload_files() {
341   inform "Uploading files"
342
343   changedir "${WORKING_DIRECTORY}"
344
345   # Make sure the directory exists on the server.
346   if [ $LOCAL -eq 0 ]; then
347     ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
348       mkdir -p "${FTP_PATH}/diffs"
349     UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
350   else
351     mkdir -p "${FTP_PATH}/diffs" \
352       || error "Could not create \`${FTP_PATH}'"
353     UPLOAD_PATH=${FTP_PATH}
354   fi
355
356   # Then copy files to their respective (sub)directories.
357   for x in gcc*.gz gcc*.bz2; do
358     if [ -e ${x} ]; then
359       # Make sure the file will be readable on the server.
360       chmod a+r ${x}
361       # Copy it.
362       case ${x} in
363         *.diff.*)
364           SUBDIR="diffs/";
365           ;;
366         *)
367           SUBDIR="";
368       esac
369       ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
370         || error "Could not upload ${x}"
371     fi
372   done
373 }
374
375 ########################################################################
376 # Initialization
377 ########################################################################
378
379 # Today's date.
380 DATE=`date "+%Y%m%d"`
381 LONG_DATE=`date "+%Y-%m-%d"`
382
383 # The CVS server containing the GCC repository.
384 CVS_SERVER="gcc.gnu.org"
385 # The path to the repository on that server.
386 CVS_REPOSITORY="/cvs/gcc"
387 # The CVS protocol to use.
388 CVS_PROTOCOL="ext"
389 # The username to use when connecting to the server.
390 CVS_USERNAME="${USER}"
391
392 # The machine to which files will be uploaded.
393 GCC_HOSTNAME="gcc.gnu.org"
394 # The name of the account on the machine to which files are uploaded.
395 GCC_USERNAME="gccadmin"
396 # The directory in which the files will be placed.
397 FTP_PATH="~ftp/pub/gcc"
398
399 # The major number for the release.  For release `3.0.2' this would be 
400 # `3'
401 RELEASE_MAJOR=""
402 # The minor number for the release.  For release `3.0.2' this would be
403 # `0'.
404 RELEASE_MINOR=""
405 # The revision number for the release.  For release `3.0.2' this would
406 # be `2'.
407 RELEASE_REVISION=""
408 # The complete name of the release.
409 RELEASE=""
410
411 # The name of the branch from which the release should be made.
412 BRANCH=""
413
414 # The tag to apply to the sources used for the release.
415 TAG=""
416
417 # The old tarballs from which to generate diffs.
418 OLD_TARS=""
419
420 # The directory that will be used to construct the release.  The
421 # release itself will be placed in a subdirectory of this diretory.
422 DESTINATION=${HOME}
423 # The subdirectory.
424 WORKING_DIRECTORY=""
425 # The directory that will contain the GCC sources.
426 SOURCE_DIRECTORY=""
427
428 # The directories that should be part of the various language-specific
429 # tar files.  These are all relative to the top of the source tree.
430 ADA_DIRS="gcc/ada"
431 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
432 FORTRAN_DIRS="gcc/f libf2c"
433 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
434 OBJECTIVEC_DIRS="gcc/objc libobjc"
435 TESTSUITE_DIRS="gcc/testsuite"
436
437 # Non-zero if this is the final release, rather than a prerelease.
438 FINAL=0
439
440 # Non-zero if we are building a snapshot, and don't build gcc or
441 # include generated files.
442 SNAPSHOT=0
443
444 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
445 # and copy directly to the FTP directory.
446 LOCAL=0
447
448 # Major operation modes.
449 MODE_BZIP2=0
450 MODE_DIFFS=0
451 MODE_SOURCES=0
452 MODE_TARFILES=0
453 MODE_UPLOAD=0
454
455 # .gz files generated to create .bz2 files from.
456 FILE_LIST=""
457
458 # Programs we use.
459
460 BZIP2="${BZIP2:-bzip2}"
461 CVS="${CVS:-cvs -f -Q -z9}"
462 DIFF="${DIFF:-diff -Nrc3pad}"
463 ENV="${ENV:-env}"
464 GZIP="${GZIP:-gzip --best}"
465 SCP="${SCP:-scp -p}"
466 SSH="${SSH:-ssh}"
467 TAR="${TAR:-tar}"
468
469 ########################################################################
470 # Command Line Processing
471 ########################################################################
472
473 # Parse the options.
474 while getopts "d:fr:u:t:p:sl" ARG; do
475     case $ARG in
476     d)    DESTINATION="${OPTARG}";;
477     r)    RELEASE="${OPTARG}";;
478     t)    TAG="${OPTARG}";;
479     u)    CVS_USERNAME="${OPTARG}";;
480     f)    FINAL=1;;
481     s)    SNAPSHOT=1;;
482     l)    LOCAL=1
483           SCP=cp
484           FTP_PATH=~ftp/pub/gcc
485           PATH=~:/usr/local/bin:$PATH;;
486     p)    OLD_TARS="${OLD_TARS} ${OPTARG}"
487           if [ -d ${OPTARG} ]; then
488             error "-p argument must name a tarball"
489           fi;;
490     \?)   usage;;
491     esac
492 done
493 shift `expr ${OPTIND} - 1`
494
495 # Perform consistency checking.
496 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
497   error "No username specified"
498 fi
499
500 if [ ! -d ${DESTINATION} ]; then
501   error "\`${DESTINATION}' is not a directory"
502 fi
503
504 if [ $SNAPSHOT -eq 0 ]; then
505   if [ -z ${RELEASE} ]; then
506     error "No release number specified"
507   fi
508
509   # Compute the major and minor release numbers.
510   RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
511   RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
512   RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
513
514   if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
515     error "Release number \`${RELEASE}' is invalid"
516   fi
517
518   # Compute the full name of the release.
519   if [ -z "${RELEASE_REVISION}" ]; then
520     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
521   else
522     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
523   fi
524
525   # Compute the name of the branch, which is based solely on the major
526   # and minor release numbers.
527   BRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
528
529   # If this is not a final release, set various parameters acordingly.
530   if [ ${FINAL} -ne 1 ]; then
531     RELEASE="${RELEASE}-${DATE}"
532     FTP_PATH="${FTP_PATH}/snapshots/"
533   else
534     FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
535   fi
536 else
537   RELEASE=$DATE
538   # For now snapshots come from the 3.3 branch.
539   BRANCH=gcc-3_3-branch
540   FTP_PATH="${FTP_PATH}/snapshots/${LONG_DATE}"
541   TAG=gcc_ss_${DATE}
542
543   # Building locally on gcc.gnu.org, we know what the last snapshot date
544   # was.
545   if [ $LOCAL -ne 0 ]; then
546     LAST_DATE=`cat ~/.snapshot_date`
547     LAST_LONG_DATE=`date --date=$LAST_DATE +%Y-%m-%d`
548     LAST_DIR=~ftp/pub/gcc/snapshots/${LAST_LONG_DATE}
549     OLD_TARS=${LAST_DIR}/gcc-${LAST_DATE}.tar.gz
550   fi
551 fi
552
553 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
554 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
555 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
556
557 # Recompute the names of all the language-specific directories,
558 # relative to the WORKING_DIRECTORY.
559 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
560 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
561 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
562 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
563 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
564 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
565
566 # Set up CVSROOT.
567 if [ $LOCAL -eq 0 ]; then
568     CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
569     CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
570 else
571     CVSROOT="${CVS_REPOSITORY}"
572 fi
573 export CVSROOT
574
575 ########################################################################
576 # Main Program
577 ########################################################################
578
579 # Set the timezone to UTC
580 TZ="UTC0"
581 export TZ
582
583 # Handle the major modes.
584 while [ $# -ne 0 ]; do
585     case $1 in
586     bzip2)    MODE_BZIP2=1;;
587     diffs)    MODE_DIFFS=1;;
588     sources)  MODE_SOURCES=1;;
589     tarfiles) MODE_TARFILES=1;;
590     upload)   MODE_UPLOAD=1;;
591     all)      MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_BZIP2=1; MODE_UPLOAD=1;;
592     *)        error "Unknown mode $1";;
593     esac
594     shift
595 done
596
597 # Build the source directory.
598
599 if [ $MODE_SOURCES -ne 0 ]; then
600   build_sources
601 fi
602
603 # Build the tar files.
604
605 if [ $MODE_TARFILES -ne 0 ]; then
606   build_tarfiles
607 fi
608
609 # Build diffs
610
611 if [ $MODE_DIFFS -ne 0 ]; then
612   # Possibly build diffs.
613   if [ -n "$OLD_TARS" ]; then
614     for old_tar in $OLD_TARS; do
615       build_diffs $old_tar
616     done
617   fi
618 fi
619
620 # Build bzip2 files
621 if [ $MODE_BZIP2 -ne 0 ]; then
622   build_bzip2
623 fi
624
625 # Upload them to the FTP server.
626
627 if [ $MODE_UPLOAD -ne 0 ]; then
628   upload_files
629
630   # For snapshots, make some further updates.
631   if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
632     # Update links on the FTP server.
633     TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
634     cd ~ftp/pub/gcc/snapshots
635     sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
636       -e "s%@LONG_DATE@%$LONG_DATE%g" \
637       -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
638     mv $$ README
639     sed -e "s%@DATE@%$DATE%g" -e "s%@LAST_DATE@%$LAST_DATE%g" \
640       -e "s%@LONG_DATE@%$LONG_DATE%g" \
641       -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
642     mv $$ index.html
643
644     touch LATEST-IS-$LONG_DATE
645     rm -f LATEST-IS-$LAST_LONG_DATE
646
647     # Update snapshot date file.
648     changedir ~
649     echo $DATE >.snapshot_date
650
651     # Update gcc_latest_snapshot tag.
652     ${CVS} rtag -d gcc_latest_snapshot gcc
653     ${CVS} rtag -rgcc_ss_${DATE} gcc_latest_snapshot gcc
654
655     # Announce the snapshot.
656     export QMAILHOST=gcc.gnu.org
657     mail -s "gcc-ss-$DATE is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/README
658
659     # Remove working directory
660     rm -rf ${WORKING_DIRECTORY}
661   fi
662 fi